# lib/psm.h File Reference

Package state machine to handle a package from a transaction set. More...

`#include <rpmsq.h>`

Include dependency graph for psm.h:

This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Data Structures

struct | rpmpsm_s

## Defines

#define | PSM_VERBOSE 0x8000
#define | PSM_INTERNAL 0x4000
#define | PSM_SYSCALL 0x2000
#define | PSM_DEAD 0x1000
#define | _fv(_a) ((_a) | PSM_VERBOSE)
#define | _fi(_a) ((_a) | PSM_INTERNAL)
#define | _fs(_a) ((_a) | (PSM_INTERNAL | PSM_SYSCALL))
#define | _fd(_a) ((_a) | (PSM_INTERNAL | PSM_DEAD))
#define | rpmpsmUnlink(_psm, _msg) XrpmpsmUnlink(_psm, _msg, __FILE__, __LINE__)
#define | rpmpsmLink(_psm, _msg) XrpmpsmLink(_psm, _msg, __FILE__, __LINE__)
#define | rpmpsmUNSAFE rpmpsmSTAGE

## Typedefs

typedef enum pkgStage_e | pkgStage

## Enumerations

enum

pkgStage_e {
PSM_UNKNOWN = 0, PSM_INIT = 1, PSM_PRE = 2, PSM_PROCESS = 3,
PSM_POST = 4, PSM_UNDO = 5, PSM_FINI = 6, PSM_PKGINSTALL = 7,
PSM_PKGERASE = 8, PSM_PKGCOMMIT = 10, PSM_PKGSAVE = 12, PSM_CREATE = 17,
PSM_NOTIFY = 22, PSM_DESTROY = 23, PSM_COMMIT = 25, PSM_CHROOT_IN = 51,
PSM_CHROOT_OUT = 52, PSM_SCRIPT = 53, PSM_TRIGGERS = 54, PSM_IMMED_TRIGGERS = 55,
PSM_RPMIO_FLAGS = 56, PSM_RPMDB_LOAD = 97, PSM_RPMDB_ADD = 98, PSM_RPMDB_REMOVE = 99
}

## Functions

rpmpsm | rpmpsmUnlink (rpmpsm psm, const char *msg)
| Unreference a package state machine instance.
rpmpsm | XrpmpsmUnlink (rpmpsm psm, const char *msg, const char *fn, unsigned ln)
rpmpsm | rpmpsmLink (rpmpsm psm, const char *msg)
| Reference a package state machine instance.
rpmpsm | XrpmpsmLink (rpmpsm psm, const char *msg, const char *fn, unsigned ln)
rpmpsm | rpmpsmFree (rpmpsm psm)
| Destroy a package state machine.
rpmpsm | rpmpsmNew (rpmts ts, rpmte te, rpmfi fi)
| Create and load a package state machine.
rpmRC | rpmpsmStage (rpmpsm psm, pkgStage stage)
| Package state machine driver.

## Variables

int | _psm_debug

## Detailed Description

Package state machine to handle a package from a transaction set.

Definition in file psm.h.

## Define Documentation

#define _fd | ( | _a |  | ) | ((_a) | (PSM_INTERNAL | PSM_DEAD))

Definition at line 25 of file psm.h.

#define _fi | ( | _a |  | ) | ((_a) | PSM_INTERNAL)

Definition at line 23 of file psm.h.

#define _fs | ( | _a |  | ) | ((_a) | (PSM_INTERNAL | PSM_SYSCALL))

Definition at line 24 of file psm.h.

#define _fv | ( | _a |  | ) | ((_a) | PSM_VERBOSE)

Definition at line 22 of file psm.h.

#define PSM_DEAD 0x1000

Definition at line 21 of file psm.h.

#define PSM_INTERNAL 0x4000

Definition at line 19 of file psm.h.

#define PSM_SYSCALL 0x2000

Definition at line 20 of file psm.h.

#define PSM_VERBOSE 0x8000

Definition at line 18 of file psm.h.

#define rpmpsmLink | ( | _psm,
|  | _msg |  | ) | XrpmpsmLink(_psm, _msg, __FILE__, __LINE__)

Definition at line 156 of file psm.h.

Referenced by rpmpsmNew().

#define rpmpsmUnlink | ( | _psm,
|  | _msg |  | ) | XrpmpsmUnlink(_psm, _msg, __FILE__, __LINE__)

Definition at line 137 of file psm.h.

Referenced by rpmpsmFree().

#define rpmpsmUNSAFE rpmpsmSTAGE

Definition at line 188 of file psm.h.

## Typedef Documentation

typedef enum pkgStage_e pkgStage

## Enumeration Type Documentation

enum pkgStage_e

Enumerator:

  PSM_UNKNOWN |
  PSM_INIT |
  PSM_PRE |
  PSM_PROCESS |
  PSM_POST |
  PSM_UNDO |
  PSM_FINI |
  PSM_PKGINSTALL |
  PSM_PKGERASE |
  PSM_PKGCOMMIT |
  PSM_PKGSAVE |
  PSM_CREATE |
  PSM_NOTIFY |
  PSM_DESTROY |
  PSM_COMMIT |
  PSM_CHROOT_IN |
  PSM_CHROOT_OUT |
  PSM_SCRIPT |
  PSM_TRIGGERS |
  PSM_IMMED_TRIGGERS |
  PSM_RPMIO_FLAGS |
  PSM_RPMDB_LOAD |
  PSM_RPMDB_ADD |
  PSM_RPMDB_REMOVE |

Definition at line 26 of file psm.h.

## Function Documentation

rpmpsm rpmpsmFree | ( | rpmpsm | psm | ) |

Destroy a package state machine.

Parameters:

  | psm | package state machine

Returns:
  NULL always

Definition at line 1326 of file psm.c.

References _free(), rpmpsm_s::fi, rpmpsm_s::nrefs, rpmfiFree(), rpmpsmUnlink, rpmteFree(), rpmtsFree(), rpmpsm_s::sstates, rpmpsm_s::te, and rpmpsm_s::ts.

Referenced by _processFailedPackage(), rpmtsRun(), and rpmVerifyScript().

rpmpsm rpmpsmLink | ( | rpmpsm | psm,
|  | const char * | msg |
| ) |  |  |

Reference a package state machine instance.

Parameters:

  | psm | package state machine
  | msg |

Returns:
  new package state machine reference

rpmpsm rpmpsmNew | ( | rpmts | ts,
|  | rpmte | te,
|  | rpmfi | fi |
| ) |  |  |

Create and load a package state machine.

Parameters:

  | ts | transaction set
  | te | transaction set element
  | fi | file info set

Returns:
  new package state machine

Definition at line 1359 of file psm.c.

References rpmpsm_s::fi, rpmfiLink, rpmpsmLink, RPMSCRIPT_MAX, rpmtsLink, rpmpsm_s::sstates, rpmpsm_s::te, rpmpsm_s::ts, and xcalloc().

Referenced by _processFailedPackage(), rpmtsRun(), and rpmVerifyScript().

rpmRC rpmpsmStage | ( | rpmpsm | psm,
|  | pkgStage | stage |
| ) |  |  |

Package state machine driver.

Parameters:

  | psm | package state machine data
  | stage | next stage

Returns:
  0 on success

Todo:
  Packages w/o files never get a callback, hence don't get displayed on install with -v.

Definition at line 1649 of file psm.c.

References _, _free(), alloca(), rpmpsm_s::amount, rpmDataType_u::argv, _HE_s::c, rpmpsm_s::cfd, Chdir(), Chroot(), rpmpsm_s::chrootDone, rpmpsm_s::countCorrection, CPIO_MAP_GID, CPIO_MAP_MODE, CPIO_MAP_PATH, CPIO_MAP_UID, CPIO_SBIT_CHECK, cpioStrerror(), D_, dbiOpen(), errno, FA_COPYOUT, rpmpsm_s::failedFile, Fclose(), rpmpsm_s::fd, fdDup(), Fdopen(), FDSTAT_DIGEST, fdstat_op(), FDSTAT_READ, FDSTAT_WRITE, Ferror(), Fflush(), rpmpsm_s::fi, Fileno(), Fopen(), FSM_PKGBUILD, FSM_PKGCOMMIT, FSM_PKGERASE, FSM_PKGINSTALL, fsmSetup(), fsmTeardown(), Fstrerror(), rpmpsm_s::goal, hCopyTag(), headerCopyLoad(), headerFini(), headerFree(), headerGet(), headerGetInstance(), headerInit(), headerIsEntry(), headerLink(), headerNew(), headerNext(), headerPut(), headerRegenSigHeader(), headerReload(), headerSetInstance(), headerSprintf(), hLoadTID(), hSaveFlinks(), markReplacedFiles(), rpmpsm_s::mi, rpmpsm_s::npkgs_installed, rpmpsm_s::oh, _HE_s::p, rpmpsm_s::payload_format, rpmpsm_s::pkgfn, pkgStageString(), rpmpsm_s::pkgURL, populateInstallHeader(), postPopulateInstallHeader(), rpmpsm_s::progTag, PSM_CHROOT_IN, PSM_CHROOT_OUT, PSM_COMMIT, PSM_CREATE, PSM_DESTROY, PSM_FINI, PSM_IMMED_TRIGGERS, PSM_INIT, PSM_NOTIFY, PSM_PKGCOMMIT, PSM_PKGERASE, PSM_PKGINSTALL, PSM_PKGSAVE, PSM_POST, PSM_PRE, PSM_PROCESS, PSM_RPMDB_ADD, PSM_RPMDB_LOAD, PSM_RPMDB_REMOVE, PSM_RPMIO_FLAGS, PSM_SCRIPT, PSM_TRIGGERS, PSM_UNDO, PSM_UNKNOWN, rpmDataType_u::ptr, rpmpsm_s::rc, RPM_STRING_TYPE, RPM_UINT32_TYPE, RPMCALLBACK_CPIO_ERROR, RPMCALLBACK_INST_PROGRESS, RPMCALLBACK_INST_START, RPMCALLBACK_UNINST_START, RPMCALLBACK_UNINST_STOP, RPMCALLBACK_UNPACK_ERROR, rpmdbAdd(), rpmdbCountPackages(), rpmdbFreeIterator(), rpmdbGetIteratorOffset(), RPMDBI_PACKAGES, rpmdbNextIterator(), rpmdbRemove(), rpmdbSetIteratorRE(), rpmfiFC(), RPMFILE_STATE_NORMAL, rpmGenPath(), rpmGetPath(), rpmHeaderFormats, rpmpsm_s::rpmio_flags, rpmlog(), RPMLOG_DEBUG, RPMLOG_ERR, RPMLOG_INFO, rpmMkdirPath(), rpmpkgSizeof(), rpmpkgWrite(), rpmpsmNext(), RPMRC_FAIL, RPMRC_OK, rpmswAdd(), rpmswEnter(), rpmswExit(), RPMTAG_HEADERIMAGE, RPMTAG_HEADERIMMUTABLE, RPMTAG_HEADERSIGNATURES, rpmteA(), rpmteE(), rpmteFd(), rpmteHdrid(), rpmteN(), rpmteNEVR(), rpmteO(), rpmteR(), rpmteSetDBInstance(), rpmteSetHeader(), rpmteV(), RPMTRANS_FLAG_APPLYONLY, RPMTRANS_FLAG_JUSTDB, RPMTRANS_FLAG_NOPOST, RPMTRANS_FLAG_NOPOSTUN, RPMTRANS_FLAG_NOPRE, RPMTRANS_FLAG_NOPREUN, RPMTRANS_FLAG_NOTRIGGERIN, RPMTRANS_FLAG_NOTRIGGERPOSTUN, RPMTRANS_FLAG_NOTRIGGERPREIN, RPMTRANS_FLAG_NOTRIGGERUN, RPMTRANS_FLAG_PKGCOMMIT, RPMTRANS_FLAG_TEST, RPMTRANS_TYPE_AUTOROLLBACK, RPMTRANS_TYPE_ROLLBACK, RPMTS_OP_COMPRESS, RPMTS_OP_DBADD, RPMTS_OP_DBREMOVE, RPMTS_OP_DIGEST, RPMTS_OP_UNCOMPRESS, rpmtsChrootDone(), rpmtsColor(), rpmtsCurrDir(), rpmtsFlags(), rpmtsGetRdb(), rpmtsGetTid(), rpmtsInitIterator(), rpmtsNotify(), rpmtsOp(), rpmtsRootDir(), rpmtsSetChrootDone(), rpmtsType(), rpmtsVSFlags(), RPMVSF_NOHDRCHK, runImmedTriggers(), runInstScript(), runTriggers(), rpmpsm_s::scriptArg, rpmpsm_s::scriptTag, rpmpsm_s::sense, snprintf(), rpmpsm_s::stepName, stpcpy(), rpmDataType_u::str, _HE_s::t, _HE_s::tag, tag2sln(), rpmpsm_s::te, rpmpsm_s::total, rpmpsm_s::ts, rpmDataType_u::ui32p, urlPath(), rpmpsm_s::what, xmalloc(), and xstrdup().

Referenced by _processFailedPackage(), rpmInstallSourcePackage(), rpmpsmNext(), rpmtsRun(), and rpmVerifyScript().

rpmpsm rpmpsmUnlink | ( | rpmpsm | psm,
|  | const char * | msg |
| ) |  |  |

Unreference a package state machine instance.

Parameters:

  | psm | package state machine
  | msg |

Returns:
  NULL always

rpmpsm XrpmpsmLink | ( | rpmpsm | psm,
|  | const char * | msg,
|  | const char * | fn,
|  | unsigned | ln |
| ) |  |  |

Todo:
  Remove debugging entry from the ABI.

Definition at line 1313 of file psm.c.

References _psm_debug, and rpmpsm_s::nrefs.

rpmpsm XrpmpsmUnlink | ( | rpmpsm | psm,
|  | const char * | msg,
|  | const char * | fn,
|  | unsigned | ln |
| ) |  |  |

Todo:
  Remove debugging entry from the ABI.

Definition at line 1302 of file psm.c.

References _psm_debug, and rpmpsm_s::nrefs.

## Variable Documentation

int _psm_debug

Definition at line 39 of file psm.c.